package io.smallrye.faulttolerance.core.timer;

import java.util.Locale;
import java.io.Serializable;
import io.smallrye.faulttolerance.core.timer.TimerTask;
import java.lang.String;
import org.jboss.logging.Logger;
import java.lang.Exception;


import static org.jboss.logging.Logger.Level.TRACE;
import static org.jboss.logging.Logger.Level.WARN;

/**
 * Warning this class consists of generated code.
 */
public class TimerLogger_$logger implements TimerLogger, Serializable {
    private static final long serialVersionUID = 1L;
    private static final String FQCN = TimerLogger_$logger.class.getName();
    public TimerLogger_$logger(final Logger log) {
        this.log = log;
    }
    protected final Logger log;
    private static final Locale LOCALE = Locale.ROOT;
    protected Locale getLoggingLocale() {
        return LOCALE;
    }
    @Override
    public final void created(final String name) {
        log.logf(FQCN, TRACE, null, created$str(), name);
    }
    protected String created$str() {
        return "Timer %s created";
    }
    @Override
    public final void shutdown(final String name) {
        log.logf(FQCN, TRACE, null, shutdown$str(), name);
    }
    protected String shutdown$str() {
        return "Timer %s shut down";
    }
    @Override
    public final void scheduledTask(final io.smallrye.faulttolerance.core.timer.TimerTask task, final long millis) {
        if (log.isEnabled(TRACE)) {
            final int taskHashCode;
            if (task == null) taskHashCode = 0; else taskHashCode = System.identityHashCode(task);
            log.logf(FQCN, TRACE, null, scheduledTask$str(), taskHashCode, millis);
        }
    }
    protected String scheduledTask$str() {
        return "Scheduled task %s to run in %s millis";
    }
    @Override
    public final void runningTask(final io.smallrye.faulttolerance.core.timer.TimerTask task) {
        if (log.isEnabled(TRACE)) {
            final int taskHashCode;
            if (task == null) taskHashCode = 0; else taskHashCode = System.identityHashCode(task);
            log.logf(FQCN, TRACE, null, runningTask$str(), taskHashCode);
        }
    }
    protected String runningTask$str() {
        return "Running task %s";
    }
    @Override
    public final void cancelledTask(final io.smallrye.faulttolerance.core.timer.TimerTask task) {
        if (log.isEnabled(TRACE)) {
            final int taskHashCode;
            if (task == null) taskHashCode = 0; else taskHashCode = System.identityHashCode(task);
            log.logf(FQCN, TRACE, null, cancelledTask$str(), taskHashCode);
        }
    }
    protected String cancelledTask$str() {
        return "Cancelled task %s";
    }
    @Override
    public final void unexpectedExceptionInTimerLoop(final Exception e) {
        log.logf(FQCN, WARN, e, unexpectedExceptionInTimerLoop$str());
    }
    protected String unexpectedExceptionInTimerLoop$str() {
        return "SRFTL11000: Unexpected exception in timer loop, ignoring";
    }
}
